#include "stdafx.h"
#include "MyList.h"


MyList::MyList()
{
	m_pHead = m_pTail = NULL;
	m_nCount = 0;
}

MyList::~MyList()
{
	RemoveAll();
}


void MyList::AddHead(DATA data)
{
	SNode *pNew = new SNode;
	pNew->data = data;
	pNew->pPrev = NULL;
	pNew->pNext = m_pHead;

	if (NULL == m_pHead)
	{
		m_pHead = pNew;
	}
	else
	{
		m_pHead->pPrev = pNew;
	}

	m_pHead = pNew;
	++m_nCount;
}

void MyList::AddTail(DATA data)
{
	SNode *pNew = new SNode;
	pNew->data = data;
	pNew->pPrev = m_pTail;
	pNew->pNext = NULL;

	if (NULL == m_pTail)
	{
		m_pHead = pNew;
	}
	else
	{
		m_pTail->pNext = pNew;
	}

	m_pTail = pNew;
	++m_nCount;
}


void MyList::SetAt(POSITION pos, DATA data)
{
	((SNode*)pos)->data = data;
}

void MyList::RemoveAt(POSITION pos)
{
	SNode *pDel = (SNode*)pos;
	if (m_pHead == pDel)
	{
		m_pHead = pDel->pNext;
	}
	else
	{
		pDel->pPrev->pNext = pDel->pNext;
	}

	if (m_pTail == pDel)
	{
		m_pTail = pDel->pPrev;
	}
	else
	{
		pDel->pNext->pPrev = pDel->pPrev;
	}

	--m_nCount;
}

void MyList::RemoveAll()
{
	SNode *pLoop = m_pHead;
	while (NULL != pLoop)
	{
		SNode *pDel = pLoop;
		pLoop = pLoop->pNext;
		delete pDel;
	}

	m_pHead = m_pTail = NULL;
	m_nCount = 0;
}


DATA& MyList::GetAt(POSITION pos)
{
	return ((SNode*)pos)->data;
}

DATA& MyList::GetAt(POSITION pos) const
{
	return ((SNode*)pos)->data;
}

DATA& MyList::GetNext(POSITION &pos)
{
	SNode *pData = (SNode*)pos;
	pos = pData->pNext;
	return pData->data;
}

DATA& MyList::GetPrev(POSITION &pos)
{
	SNode *pData = (SNode*)pos;
	pos = pData->pPrev;
	return pData->data;
}


POSITION MyList::GetHeadPosition()
{
	return m_pHead;
}

POSITION MyList::GetTailPosition()
{
	return m_pTail;
}

int MyList::GetCount()
{
	return m_nCount;
}